Bug 912299 - kernel installation fails if GREP_OPTIONS is set
kernel installation fails if GREP_OPTIONS is set
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: dracut (Show other bugs)
6.3
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: Harald Hoyer
Release Test Team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-18 05:36 EST by Vasily Averin
Modified: 2013-11-21 16:55 EST (History)
4 users (show)

See Also:
Fixed In Version: dracut-004-322.el6
Doc Type: Bug Fix
Doc Text:
Cause: dracut makes use of "grep" without unsetting the environment variable GREP_OPTIONS. Consequence: If the user has set GREP_OPTIONS while calling yum or running dracut, usages of the "grep" tool could fail because of arbitrary options. Fix: dracut now unsets the GREP_OPTIONS environment variable. Result: User settings of the GREP_OPTIONS environment variable does not affect the correct operation of dracut anymore.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-21 16:55:06 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Vasily Averin 2013-02-18 05:36:33 EST
Description of problem:
kernel installation fails if environment contains GREP_OPTIONS="--color=always" variable.

# rpm -q dracut-network
dracut-network-004-283.el6.noarch

# export GREP_OPTIONS="--color=always"
# rpm -ihv kernel-2.6.32-279.22.1.el6.x86_64.rpm kernel-firmware-2.6.32-279.22.1.el6.noarch.rpm 
Preparing...                ########################################### [100%]
   1:kernel-firmware        ########################################### [ 50%]
   2:kernel                 ########################################### [100%]
The default plymouth plugin (text) doesn't exist
E: Failed to install /lib64/libnss_dns-2.12.so
mkinitrd failed
warning: %posttrans(kernel-2.6.32-279.22.1.el6.x86_64) scriptlet failed, exit status 1

Version-Release number of selected component (if applicable):
dracut-network-004-283.el6.noarch

How reproducible: 100%

Steps to Reproduce:
1. be sure that dracut-network is installed
2. set up GREP_OPTIONS variable:
 # export GREP_OPTIONS="--color=always"
3. try to install new kernel
  
Actual results:
dracut fails with following message in dracut.log
Mon Feb 18 13:55:34 MSK 2013 Err: Failed to install /lib64/libnss_ESC[01;31mESC[KdnsESC[mESC[K-2.12.so

Expected results:
no errors

Additional info:
with dracut debug we have found that problem occurs during execution
/usr/share/dracut/modules.d/95nfs/install

dracut_install $(for i in $(ls {/usr,}$LIBDIR/libnss*.so 2>/dev/null); do echo $i;done | egrep "$nsslibs")

Using "egrep -q" resolved the problem.

In upstream dracut code the problem went away with following commit
http://git.kernel.org/?p=boot/dracut/dracut.git;a=commitdiff;h=5e5f3d5e6c9d94996c9a28bf38f26a4d463c4dd4
Comment 7 Harald Hoyer 2013-07-18 09:54:04 EDT
First alpha build for testing:
http://people.redhat.com/harald/downloads/dracut/dracut-004-316.el6/

Would be nice, if you could test it.
Comment 8 Vasily Averin 2013-08-05 02:42:54 EDT
I can confirm that  problem is resolved with dracut-004-316.el6
Comment 10 Jan Stodola 2013-10-21 06:11:05 EDT
Reproduced with dracut-004-303.el6:

[root@localhost ~]# rpm -i --force kernel-2.6.32-424.el6.x86_64.rpm 
warning: kernel-2.6.32-424.el6.x86_64.rpm: Header V3 RSA/SHA256 Signature, key ID f21541eb: NOKEY
The default plymouth plugin (text) doesn't exist
E: Failed to install /lib64/libnss_dns-2.12.so
mkinitrd failed
warning: %posttrans(kernel-2.6.32-424.el6.x86_64) scriptlet failed, exit status 1
[root@localhost ~]# rpm -q dracut
dracut-004-303.el6.noarch
[root@localhost ~]# 

Verified with dracut-004-335.el6:

[root@localhost ~]# rpm -i --force kernel-2.6.32-424.el6.x86_64.rpm 
warning: kernel-2.6.32-424.el6.x86_64.rpm: Header V3 RSA/SHA256 Signature, key ID f21541eb: NOKEY
[root@localhost ~]# rpm -q dracut
dracut-004-335.el6.noarch
[root@localhost ~]#

System booted correctly after reboot.

Moving to VERIFIED.
Comment 11 errata-xmlrpc 2013-11-21 16:55:06 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-1674.html

Note You need to log in before you can comment on or make changes to this bug.